/*!
* @file ItemBase.h
* @brief ゲーム中のアイテムベースのプロトタイプ
* @date 2014/02/01
* @author Deskull
* 2014 Sikabane Works.
*/

#include "stdafx.h"
#include "Dice.h"
#include "ItemTemplate.h"
#include "GameElement.h"
#include "SavingTable.h"

BOOST_CLASS_VERSION(ItemBase, 1);

namespace Deeangband
{

	/*! @class ItemBase
	*  @brief アイテムベースのクラス
	*/
	class ItemBase : public ItemTemplate
	{
	private:
		std::string name; //!< ベースアイテムの名前
		Dice baseDamage; //!< ベースダメージのダイス
		WEIGHT weight; //!< アイテムの重量
		SavingTable baseSaving; //!< 基本セービング修正
		SavingTable plusSaving; //!< 追加セービング修正

		friend class boost::serialization::access;
		template<class Archive> void serialize(Archive &archive, const unsigned int) 
		{
			archive & BOOST_SERIALIZATION_NVP(name);
			archive & BOOST_SERIALIZATION_NVP(baseDamage);
			archive & BOOST_SERIALIZATION_NVP(weight);
			archive & BOOST_SERIALIZATION_NVP(baseSaving);
			archive & BOOST_SERIALIZATION_NVP(plusSaving);
		}

	public:

		/*! 
		* @brief ItemBaseクラスコンストラクタ(GameElementメンバ対応)
		* @param id GameElementのID
		* @param tag GameElementのタグ
		* @param gameWorld 所属元gameWorld参照ポインタ
		*/
		ItemBase::ItemBase(ID id, TAG tag, GameWorld *gameWorld);

		/*! 
		* @brief ItemBaseクラスコンストラクタ
		*/
		ItemBase::ItemBase(void);

		/*! 
		* @brief ItemBaseデストラクタ
		*/
		ItemBase::~ItemBase(void);

		/*! 
		* @brief アイテムの重量を返す
		* @return アイテムの重量
		*/
		WEIGHT ItemBase::GetWeight(void);

		/*! 
		* @brief アイテムのダメージダイスを返す
		* @return アイテムのダメージダイス
		*/
		Dice ItemBase::GetDamageDice(void);

		/*! 
		* @brief ダミーデータによる初期化
		* @return なし
		*/
		void ItemBase::SetDammyData(void);



		/*!
		* @brief XMLシリアライズによるゲームデータ保存処理
		* @return なし
		*/
		void ItemBase::XMLSave(std::string filename);

	};

}